// FileDialogEx.cpp : implementation file
//

#include "stdafx.h"
#include "MyFileDialog.h"
#include "FileDialogEx.h"
#include <dlgs.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileDialogEx

IMPLEMENT_DYNAMIC(CFileDialogEx, CFileDialog)

CFileDialogEx::CFileDialogEx(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd) :
		CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd)
{
}


BEGIN_MESSAGE_MAP(CFileDialogEx, CFileDialog)
	//{{AFX_MSG_MAP(CFileDialogEx)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CFileDialogEx::OnInitDialog() 
{
	CFileDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	// We need to enlarge standard CFileDialog to make space for our controls
	// idea from Christian Skovdal Andersen article - Customizing CFileDialog
	char szText[120];
    
	// This variable should be changed acording to your wishes
	const UINT iExtraSize = 50;
	// Get a pointer to the original dialog box.
	CWnd *wndDlg = GetParent();
	RECT Rect;

	wndDlg->GetWindowRect(&Rect);
	// Change the size of FileOpen dialog
	wndDlg->SetWindowPos(NULL, 0, 0, 
                        Rect.right - Rect.left, 
                        Rect.bottom - Rect.top + iExtraSize, 
                        SWP_NOMOVE);

	// Standard CFileDialog control ID's are defined in <dlgs.h>
	// Do not forget to include <dlgs.h> in implementation file

	CWnd *wndComboCtrl = wndDlg->GetDlgItem(cmb1);	// cmb1 - standard file name combo box control
	wndComboCtrl->GetWindowRect(&Rect);
	wndDlg->ScreenToClient(&Rect); // Remember it is child controls

	// Put our control(s) somewhere below HIDDEN checkbox
	// Make space for 3 different subtypes
	Rect.top += 60;
	Rect.bottom += 120;
	Rect.left += 50;

	// Our control is CComboBox object
	// IMPORTANT: We must put wndDlg here as hWndParents, NOT "this" as
	// written in Microsoft documentation example
	// NOTE: IDC_MYCOMBOBOX and IDC_MYSTATIC must be defined (best in resource.h)
	m_Combo.Create(WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | CBS_SORT | WS_VSCROLL | WS_TABSTOP,
		Rect, wndDlg, IDC_MYCOMBOBOX);
	// save new control font according to other controls font
	m_Combo.SetFont(wndComboCtrl->GetFont(), TRUE);
	m_Combo.SetFocus();
	// We also need Static Control. Get coordinates from stc3 control
	CWnd *wndStaticCtrl = wndDlg->GetDlgItem(stc2);
	wndStaticCtrl->GetWindowRect(&Rect);
	wndDlg->ScreenToClient(&Rect);
	Rect.top += 60;
	Rect.bottom += 80;
	Rect.right += 40;

	// our static control
	m_Static.Create("Proba", WS_CHILD | WS_VISIBLE, Rect, wndDlg, IDC_MYSTATIC);
	m_Static.SetFont(wndComboCtrl->GetFont(), TRUE);

	// Now, fill up static control and combo control
	// Our ComboBox control will offer three diffirent file subtypes. 
	// Current file subtype is held in m_nSubType member variable which
	// will hold resulting (final) subtype, also.
	for (int i=0; i < 3; i++) {
		sprintf(szText, "Subtype%d", i);
		wndDlg->SendDlgItemMessage(IDC_MYCOMBOBOX, CB_INSERTSTRING,
			(WPARAM) (-1), (LPARAM) (szText));
		// Set displayed subtype to sybtype format of working file
		if (m_nSubType == i)
			wndDlg->SetDlgItemText(IDC_MYCOMBOBOX, szText);
	}
	// Add some general text for static box
	sprintf(szText, "File SubType Format");
	wndDlg->SetDlgItemText(IDC_MYSTATIC, szText);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFileDialogEx::OnDestroy() 
{
	CFileDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	char szText[40];

	// get/save SaveAs file subtype
	if (GetParent()->GetDlgItemText(IDC_MYCOMBOBOX, szText, sizeof(szText)) > 0)
		m_nSubType = szText[strlen(szText)-1] - '0';
	
}
